//
//  MouseScene.cpp
//  layer_mouse
//
//  Created by Reza Ghobadinic on 2019-10-24.
//

#include "MouseScene.h"
#include <iostream>

USING_NS_CC;
using namespace std;

Scene* MouseScene::createScene()
{
    auto scene = Scene::create();
    auto layer = MouseScene::create();
    
    scene->addChild(layer);
    
    return scene;
}

bool MouseScene::init()
{
    auto listener = EventListenerMouse::create(); // Create a mouse listener
    
    /** /
    listener->onMouseUp     = CC_CALLBACK_1(MouseScene::onMouseUp, this);
    listener->onMouseDown   = CC_CALLBACK_1(MouseScene::onMouseDown, this);
    listener->onMouseMove   = CC_CALLBACK_1(MouseScene::onMouseMove, this);
    listener->onMouseScroll = CC_CALLBACK_1(MouseScene::onMouseScroll, this);
    //*/
    
    /**/
    listener->onMouseUp = [] (Event* event){
        EventMouse* mouseEvent = dynamic_cast<EventMouse*>(event);
        cout << "Button Up: " << (int)mouseEvent->getMouseButton() << endl;
    };
    
    listener->onMouseDown = [] (Event* event){
        EventMouse* mouseEvent = dynamic_cast<EventMouse*>(event);
        cout << "Button Down: " << (int)mouseEvent->getMouseButton() << endl;
    };
    
    listener->onMouseMove = [] (Event* event){
        EventMouse* mouseEvent = dynamic_cast<EventMouse*>(event);
        cout << "X: " << mouseEvent->getCursorX() << endl;
        cout << "Y: " << mouseEvent->getCursorY() << endl;
    };
    
    listener->onMouseScroll = [] (Event* event){
        EventMouse* mouseEvent = dynamic_cast<EventMouse*>(event);
        cout << "Scroll X = " << mouseEvent->getScrollX() << endl;
        cout << "Scroll Y = " << mouseEvent->getScrollY() << endl;
    };
    //*/
    
    _eventDispatcher->addEventListenerWithSceneGraphPriority(listener, this);
    
    return true;
}

/** /
void MouseScene::onMouseUp(Event* event)
{
    EventMouse* mouseEvent = dynamic_cast<EventMouse*>(event);
    cout << "Button Up: " << (int)mouseEvent->getMouseButton() << endl;
}

void MouseScene::onMouseDown(Event* event)
{
    EventMouse* mouseEvent = dynamic_cast<EventMouse*>(event);
    cout << "Button Down: " << (int)mouseEvent->getMouseButton() << endl;
}

void MouseScene::onMouseMove(Event* event)
{
    EventMouse* mouseEvent = dynamic_cast<EventMouse*>(event);
    cout << "X: " << mouseEvent->getCursorX() << endl;
    cout << "Y: " << mouseEvent->getCursorY() << endl;
}

void MouseScene::onMouseScroll(Event* event)
{
    EventMouse* mouseEvent = dynamic_cast<EventMouse*>(event);
    cout << "Scroll X = " << mouseEvent->getScrollX() << endl;
    cout << "Scroll Y = " << mouseEvent->getScrollY() << endl;
}
//*/
